package com.tztzf.network.callback;

import com.tztzf.network.tztZFNetWorkReqObj;
import com.tztzf.network.tztZFNetWorkRespObj;

/**
 * ****************************************************************
 * 文件名称 : tztZFNetWorkResponseCallBack
 * 作   者 : Created by yangdl
 * 创建时间 : 202100309 17:06
 * 文件描述 : 数据请求应答回调
 * 注意事项 :
 * 版权声明 : Copyright (C) 2021-2030 杭州中焯信息技术股份有限公司
 * 修改历史 : 202100309 1.00 初始版本
 * ****************************************************************
 */

public interface tztZFNetWorkResponseCallBack {
    /**
     * 请求网络错误回调
     * @param c_reqObj 请求对象
     * @param c_reqObjTag 请求标示
     * @param c_recvType 应答类别
     * @param c_errorNo 错误号
     * @param c_errorMsg 请求错误
     */
    void OnError(tztZFNetWorkReqObj c_reqObj, int c_reqObjTag, int c_recvType, int c_errorNo, String c_errorMsg);

    /**
     * 请求应答回调
     * @param c_reqObj 请求对象
     * @param c_reqObjTag 请求标示
     * @param c_respObj 应答结果
     */
    void OnAns(tztZFNetWorkReqObj c_reqObj, int c_reqObjTag, tztZFNetWorkRespObj c_respObj);
}
