package com.tztzf.network.callback;

/**
 * ****************************************************************
 * 文件名称 : tztZFSocketLinkDelegate
 * 作   者 : Created by yangdl
 * 创建时间 : 202100309 17:06
 * 文件描述 : 数据请求发送之前以及数据应答接收到后回调，用于请求发送前处理、应答接收到后处理
 * 注意事项 :
 * 版权声明 : Copyright (C) 2021-2030 杭州中焯信息技术股份有限公司
 * 修改历史 : 202100309 1.00 初始版本
 * ****************************************************************
 */

import com.tztzf.network.tztZFNetWorkReqObj;
import com.tztzf.network.tztZFNetWorkRespObj;

/**
 * 数据请求发送之前以及数据应答接收到后回调，用于请求发送前处理、应答接收到后处理
 */
public interface tztZFSocketLinkDelegate {
    /**
     * 应答是否支持功能号显示错误信息
     * @return 应答是否支持功能号显示错误信息
     */
    boolean showActionForError();
    /**
     * 数据发送之前统一回调接口
     * @param c_reqObj 发送的数据
     * @param c_linkType 链接的类型
     * @return true=继续发送；false=终止发送
     */
    boolean beforeSendData(tztZFNetWorkReqObj c_reqObj, tztZFNetWorkResponseCallBack completion, int c_linkType, String linkKey);

    /**
     * 数据接收后统一回调接口
     * @param c_respObj 应答数据对象
     * @param c_linkType 链接通道类型
     */
    void afterReceiveData(tztZFNetWorkRespObj c_respObj, int c_linkType, String linkKey);
}
