package com.tztzf.network.define;

import com.tztzf.commbase.tztZFDataMapBase;
import com.tztzf.commbase.tztZFDataMapCallBack;

/**
 * ****************************************************************
 * 文件名称 : tztZFErrorMessageDefine
 * 作   者 : Created by wlz
 * 创建时间 : 2021/12/8 09:13
 * 文件描述 : 通讯层错误信息
 * 注意事项 :
 * 版权声明 : Copyright (C) 2015-2025 杭州中焯信息技术股份有限公司
 * 修改历史 : 2021/12/8 1.00 初始版本
 * ****************************************************************
 */
public class tztZFErrorMessageDefine {
    /** 是否显示自定义错误等级 */
    public static boolean tztZFShowCustomErrorCode = true;
    /** 网络状态信息 */
    public static String tztZFCommErrorMessage = "请检查网络通讯状态是否良好！"; // 如仍然有问题，请退出并重新运行本系统，然后尝试使用其它[网络连接方式]！";
    /** 连接服务器失败信息 */
    public static String tztZFConnectError = "连接失败，" + tztZFCommErrorMessage;
    /** 发送数据失败信息 */
    public static String tztZFWriteError = "发送失败，" + tztZFCommErrorMessage;
    /** 接收数据失败信息 */
    public static String tztZFReadError = "接收失败，" + tztZFCommErrorMessage;
    /** 协商失败信息 */
    public static String tztZFAgreementError = "连接超时，" + tztZFCommErrorMessage;

    /** 等待应答超时信息 */
    public static String tztZFOutTimeError = "应答超时，" + tztZFCommErrorMessage;
    /** 安全码文本 */
    public static String tztZFPinLable = "安全码";
    /** 证书文本 */
    public static String tztZFCertLable = "证书";
    /** 国密文本 */
    public static String tztZFGMLable = "国密";


    //自定义错误信息配置对应key
    /** 连接服务器失败, = "Net_ConnError", 默认:连接失败，请检查网络通讯状态是否良好 */
    public static String tztZFNetWorkErrorKey_ConnectError = "Net_ConnError";
    /** 发送数据失败 = "Net_WriteError", 默认: 发送失败，请检查网络通讯状态是否良好 */
    public static String tztZFNetWorkErrorKey_WriteError = "Net_WriteError";
    /** 接受数据失败 = "Net_ReadError", 默认: 接收失败，请检查网络通讯状态是否良好 */
    public static String tztZFNetWorkErrorKey_ReadError = "Net_ReadError";
    /** 等待应答超时 = "Net_TimeOutError", 默认: 应答超时，请检查网络通讯状态是否良好 */
    public static String tztZFNetWorkErrorKey_TimeOutError = "Net_TimeOutError";
    /** 未设置用户国密证书 = "Net_NoCert", 默认: 未设置用户有效加密证书 */
    public static String tztZFNetWorkErrorKey_NoUserCert = "Net_NoCert";
    /** 用户的国密证书过期 = "Net_CertInvalid", 默认: 请确认申请国密证书且在有效期内 */
    public static String tztZFNetWorkErrorKey_CertInvalid = "Net_CertInvalid";
    /** 当前非国密状态 = "Net_NotGMStatus", 默认：当前非国密状态 */
    public static String tztZFNetWorkErrorKey_NotGMStatus = "Net_NotGMStatus";
    /** 安全码文本 */
    public static String tztZFNetWorkErrorKey_PinLable = "tztZFPinLable";
    /** 证书文本 */
    public static String tztZFNetWorkErrorKey_CertLable = "tztZFCertLable";
    /** 国密文本 */
    public static String tztZFNetWorkErrorKey_GMLable = "tztZFGMLable";

    private static tztZFErrorMessageDefine errorMessageDefine;
    private tztZFDataMapBase<String, Object> dictConfigData = new tztZFDataMapBase<>();

    private tztZFErrorMessageDefine() {

    }

    private static tztZFErrorMessageDefine getShareInstance() {
        if (errorMessageDefine == null) {
            errorMessageDefine = new tztZFErrorMessageDefine();
        }
        return errorMessageDefine;
    }

    public static void setUserDefineError(tztZFDataMapBase<String, Object> dictUserDefine) {
        if (dictUserDefine == null)
            return;

        dictUserDefine.enumerateKeysAndObjectsUsingBlock(new tztZFDataMapCallBack() {
            @Override
            public boolean enumerate(String lowKey, String key, Object value) {
                getShareInstance().dictConfigData.setObj(key, value);
                return false;
            }
        });
    }

    public static String getUserDefineError(String key, String defaultVal) {
        String value = getShareInstance().dictConfigData.getStr(key);
        if (value == null || value.length() < 1)
            return defaultVal;
        return value;
    }
}
