package com.tztzf.network.define;

/**
 * ****************************************************************
 * 文件名称 : tztZFLinkCallbackType
 * 作   者 : Created by yangdl
 * 创建时间 : 2021-03-09 14:11
 * 文件描述 :
 * 注意事项 :
 * 版权声明 : Copyright (C) 2021-2030 杭州中焯信息技术股份有限公司
 * 修改历史 : 2021-03-09 1.00 初始版本
 * ****************************************************************
 */
public enum tztZFLinkCallBackType {
    //region 内部私有属性及函数
    /** 连接状态变更 */
    tztZFLinkCallBackType_NetState(0),
    /** Post数据 */
    tztZFLinkCallBackType_PostData(1);
    //endregion

    //region 具体实现

    //region 公布方法（允许其他包访问）
    private int value = 0;

    tztZFLinkCallBackType(int value) {
        this.value = value;
    }

    /**
     * 获取枚举int值
     * @return 枚举int值
     */
    public int value() {
        return this.value;
    }

    /**
     * int值转tztZFLinkCallBackType对象
     * @param value int值
     * @return tztZFLinkCallBackType对象
     */
    public static tztZFLinkCallBackType valueOf(int value) {
        for (tztZFLinkCallBackType c : tztZFLinkCallBackType.values()) {
            if (c.value == value)
                return c;
        }
        return null;
    }
}
