package com.tztzf.network.define;

/**
 * ****************************************************************
 * 文件名称 : tztZZRecvType
 * 作   者 : Created by wlz
 * 创建时间 : 2019-12-23 11:40
 * 文件描述 : 接收状态
 * 注意事项 :
 * 版权声明 : Copyright (C) 2015-2025 杭州中焯信息技术股份有限公司
 * 修改历史 : 2019-12-23 1.00 初始版本
 * ****************************************************************
 */
public enum tztZFRecvType {

    //region 内部私有属性及函数
    tztZFConn_Change(0),
    /** 无连接 */
    tztZFConn_Non(1),
    /** 连接成功 */
    tztZFConn_Connected(2),
    /** 断开 */
    tztZFConn_DisConnect(3),
    /** 数据接收完成 */
    tztZFRecv_DataOK(4),
    /** 错误 */
    tztZFRecv_Error(5),
    /** 应答超时 */
    tztZFRecv_TimeOut(6),
    //发送错误以tztZFSend_开头，并放在最后
    /** 超出请求队列数 */
    tztZFSend_MaxError(7),
    /** 请求被取消(主动取消，通讯被释放等) */
    tztZFSend_SendCancel(8),
    /** 发送包错误(无Action、打包失败等) */
    tztZFSend_SendError(9),
    /** 请求超时 */
    tztZFSend_TimeOut(10);

    private int value = 0;

    //endregion

    //region 具体实现

    //region 公布方法（允许其他包访问）

    /**
     * 获取枚举int值
     * @return 枚举int值
     */
    public int value() {
        return this.value;
    }

    /**
     * int值转tztZFRecvType对象
     * @param value int值
     * @return tztZFRecvType对象
     */
    public static tztZFRecvType valueOf(int value) {
        for (tztZFRecvType c : tztZFRecvType.values()) {
            if (c.value == value)
                return c;
        }
        return null;
    }

    public static String tztZFTipOfRecvType(tztZFRecvType type) {
        if (type != null) {
            switch (type) {
                case tztZFConn_Non: /**无连接*/
                    return "tztZFConn_Non";
                case tztZFConn_Change: /*网络变更*/
                    return "tztZFConn_Change";
                case tztZFConn_DisConnect: /**断开*/
                    return "tztZFConn_DisConnect";
                case tztZFSend_MaxError: /**超出请求队列数*/
                    return "tztZFSend_MaxError";
                case tztZFSend_SendCancel: /**请求被取消(主动取消，通讯被释放等)*/
                    return "tztZFSend_SendCancel";
                case tztZFSend_SendError: /**发送包错误(无Action、打包失败等)*/
                    return "tztZFSend_SendError";
                case tztZFSend_TimeOut: /**请求超时*/
                    return "tztZFSend_TimeOut";
                case tztZFRecv_TimeOut:
                    return "tztZFRecv_TimeOut";
                case tztZFRecv_Error:
                    return "tztZFRecv_Error";
                case tztZFConn_Connected:
                    return "tztZFConn_Connected";
                case tztZFRecv_DataOK:
                    return "tztZFRecv_DataOK";
                default:
                    return String.format("unKnow-%d", type.value);
            }
        }
        return "unKnow";
    }

    //endregion

    //region 保护方法（允许子类访问、允许相同包中访问）
    //endregion

    //region 内部方法（只允许相同包中访问）

    tztZFRecvType(int value) {
        this.value = value;
    }

    //endregion

    //region 私有方法（只允许自己调用）
    //endregion

    //endregion

    //region 开发新增处理代码

    //endregion

}