package com.tztzf.network.gm;

import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketSSLStepClose;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketSSLStepConnect;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketSSLStepDowngrade;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketSSLStepHand;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketSSLStepInit;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketSSLStepSocket;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketSSLStepSucess;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketSSLStepUnClientCert;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketSSLStepUnServerCert;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketStepConnect;
import static com.tztzf.network.gm.tztZFSocketSSLStep.tztZFSocketStepSucess;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

@tztZFIntDef({
        tztZFSocketSSLStepSocket,
        tztZFSocketSSLStepUnClientCert, //未加载客户端证书或证书错误
        tztZFSocketSSLStepInit, // SSL Init
        tztZFSocketSSLStepConnect, // SSL Connect
        tztZFSocketSSLStepUnServerCert, //服务器端未找到对应证书
        tztZFSocketSSLStepHand, // SSL Hand
        tztZFSocketSSLStepClose, // SSL Close
        tztZFSocketSSLStepDowngrade, // SSL 降级
        tztZFSocketSSLStepSucess,      // SSL ProtocolHand_OK
        tztZFSocketStepConnect,
        tztZFSocketStepSucess
})

@Retention(RetentionPolicy.SOURCE)
public @interface tztZFSocketSSLStep {
    int tztZFSocketSSLStepSocket = 0;
    int tztZFSocketSSLStepUnClientCert = 1; //未加载客户端证书或证书错误
    int tztZFSocketSSLStepInit = 2; // SSL Init
    int tztZFSocketSSLStepConnect = 3; // SSL Connect
    int tztZFSocketSSLStepUnServerCert = 4; //服务器端未找到对应证书
    int tztZFSocketSSLStepHand = 5; // SSL Hand
    int tztZFSocketSSLStepClose = 6; // SSL Close
    int tztZFSocketSSLStepDowngrade = 7; // SSL 降级
    int tztZFSocketSSLStepSucess = 8;// SSL ProtocolHand_OK
    int tztZFSocketStepConnect = 9;// Socket Connect
    int tztZFSocketStepSucess = 10;// Socket ProtocolHand_OK

    class tztZFSocketSSLStepTips {
        public static String tips(@tztZFSocketSSLStep int step) {
            switch (step) {
                /*SocketConnect*/
                case tztZFSocketSSLStepSocket:
                    return "tztZFSocketSSLStepSocket";
                /*未找到用户客户端部分证书或证书无效*/
                case tztZFSocketSSLStepUnClientCert:
                    return "tztZFSocketSSLStepUnClientCert";
                /*SSL_Init*/
                case tztZFSocketSSLStepInit:
                    return "tztZFSocketSSLStepInit";
                /*SSL_Connect*/
                case tztZFSocketSSLStepConnect:
                    return "tztZFSocketSSLStepConnect";
                /*未找到用户服务器部分证书或证书无效*/
                case tztZFSocketSSLStepUnServerCert:
                    return "tztZFSocketSSLStepUnServerCert";
                /*SSL_HandOK*/
                case tztZFSocketSSLStepHand:
                    return "tztZFSocketSSLStepHand";
                /*SSL_Close*/
                case tztZFSocketSSLStepClose:
                    return "tztZFSocketSSLStepClose";
                case tztZFSocketSSLStepDowngrade:
                    return "tztZFSocketSSLStepDowngrade";
                /*SSL_Sucess*/
                case tztZFSocketSSLStepSucess:
                    return "tztZFSocketSSLStepSucess";
                /*SSL_Sucess*/
                case tztZFSocketStepConnect:
                    return "tztZFSocketStepConnect";
                /*SSL_Sucess*/
                case tztZFSocketStepSucess:
                    return "tztZFSocketStepSucess";
                default:
                    return "tztZFSocketSSLStepInvaild";
            }
        }
    }
}
