package com.tztzf.network.socket.gmhttp;

import com.tztzf.commbase.tztZFDataMapBase;
import com.tztzf.log.tztZFLog;
import com.tztzf.log.tztZFLogLevel;

import java.net.URL;

public class Request {
    private URL url;
    private String method;
    private tztZFDataMapBase<String, ?> headers;
    private byte[] body;
    private long timeOut;

    // region get/set
    public URL getUrl() {
        return url;
    }

    public void setUrl(URL url) {
        this.url = url;
    }

    public String getMethod() {
        return method;
    }

    public void setMethod(String method) {
        this.method = method;
    }

    public tztZFDataMapBase<String, ?> getHeaders() {
        return headers;
    }

    public void setHeaders(tztZFDataMapBase<String, Object> headers) {
        this.headers = headers;
    }

    public byte[] getBody() {
        return body;
    }

    public void setBody(byte[] body) {
        this.body = body;
    }

    public long getTimeOut() {
        return timeOut;
    }

    public void setTimeOut(long timeOut) {
        this.timeOut = timeOut;
    }
    //endregion

    public Request(String strUrl) {
        try {
            if (strUrl != null)
                this.url = new URL(strUrl);
            headers = new tztZFDataMapBase<>();
        } catch (Exception e) {
            tztZFLog.log(tztZFLogLevel.tztZFLogLevel_Debug, "GMHTTP", "%s", tztZFLog.getStackTraceString(e));
        }
        method = "GET";
    }

    public Request(URL url) {
        method = "GET";
        headers = new tztZFDataMapBase<>();
    }

    public String getHost() {
        if (this.url == null)
            return "";

        return this.url.getHost();
    }

    public int getPort() {
        if (this.url == null)
            return 0;
        return this.url.getPort();
    }

    public String getPath() {
        if (this.url == null)
            return "";
        return this.url.getPath();
    }

    public String getQuery() {
        if (this.url == null)
            return "";
        return this.url.getQuery();
    }

    public String getHeader(String name) {
        return headers.getStr(name);
    }

    public void addHeader(String name, String value) {
        headers.setStr(name, value);
    }

    public void removeHeader(String name) {
        headers.removeByKey(name);
    }

    public void removeAllHeader() {
        headers.removeAllObjects();
    }
}
