package com.tztzf.network.socket;

import com.tztzf.base.tztZFPublicFun;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * ****************************************************************
 * 文件名称:tztZZFileIntegrityUtils.class
 * 作    者:Created by xql
 * 创建时间:2019/5/18 14:33
 * 文件描述:文件完整性以及主动挑战相关的一些工具类
 * 注意事项:
 * 版权声明:Copyright (C) 2015-2025 杭州中焯信息技术股份有限公司
 * 修改历史:2019/5/18 1.00 初始版本
 * ****************************************************************
 */
class tztZFFileIntegrityUtils {
    /**
     * 获取当前APP md5值
     * @param context 系统上下文
     * @return
     */
    public static String appMD5(Object context) {
        String strMD5 = "获取失败";
        if (context == null)
            return strMD5;
        String apkPath = tztZFPublicFun.getPackagePath(context); // 获取Apk包存储路径
        try {
            MessageDigest dexDigest = MessageDigest.getInstance("MD5");
            byte[] bytes = new byte[1024];
            int byteCount;
            FileInputStream fis = new FileInputStream(new File(apkPath)); // 读取apk文件
            while ((byteCount = fis.read(bytes)) != -1) {
                dexDigest.update(bytes, 0, byteCount);
            }
            BigInteger bigInteger = new BigInteger(1, dexDigest.digest()); // 计算apk文件的哈希值
            strMD5 = bigInteger.toString(16);
            fis.close();
        } catch (NoSuchAlgorithmException ignored) {

        } catch (FileNotFoundException ignored) {

        } catch (IOException ignored) {

        }
        return strMD5;
    }
}
