package com.tztzf.network;

import com.tztzf.network.callback.tztZFNetPoolsCallBack;
import com.tztzf.network.define.tztZFLinkType;

public class tztZFNetTestConn {

    static tztZFNetTestConn _obj = null;
    private Object context;
    private String m_sAddlist;
    private int m_nNum;
    private int m_nTimeOut;
    private int m_nConnTimeOut = 3 * 1000;
    private tztZFPoolsShortNet _poolNet;

    private static synchronized tztZFNetTestConn getShareInstance() {
        if (_obj == null) {
            _obj = new tztZFNetTestConn();
        }
        return _obj;
    }

    private tztZFNetTestConn() {
        initdata();
    }

    private void initdata() {
        context = null;
        m_sAddlist = "";
        m_nNum = 5;
        _poolNet = null;

    }

    private tztZFNetTestConn initWithContext(Object context) {
        this.context = context;
        return tztZFNetTestConn.this;
    }

    /***
     * 创建tztZFNetTestConn对象
     * @param context 上下文
     * @return tztZFNetTestConn对象
     */
    public static tztZFNetTestConn WithContext(Object context) {
        return getShareInstance().initWithContext(context);
    }

    private tztZFNetTestConn initWithAddlist(String strAddList) {
        this.m_sAddlist = strAddList;
        return tztZFNetTestConn.this;
    }

    /***
     * 创建tztZFNetTestConn对象
     * @param strAddList 服务器地址
     * @return tztZFNetTestConn对象
     */
    public static tztZFNetTestConn WithAddlist(String strAddList) {
        return getShareInstance().initWithAddlist(strAddList);
    }

    private tztZFNetTestConn initWithNum(int num) {
        this.m_nNum = num;
        return tztZFNetTestConn.this;
    }

    /***
     * 创建tztZFNetTestConn对象
     * @param num 线程池最大线程数
     * @return tztZFNetTestConn对象
     */
    public static tztZFNetTestConn WithNum(int num) {
        return getShareInstance().initWithNum(num);
    }


    private tztZFNetTestConn initWithTimeOut(int timeOut) {
        this.m_nTimeOut = timeOut;
        return tztZFNetTestConn.this;
    }

    /***
     * 创建tztZFNetTestConn对象
     * @param timeOut 超时时间
     * @return tztZFNetTestConn对象
     */
    public static tztZFNetTestConn WithTimeOut(int timeOut) {
        return getShareInstance().initWithTimeOut(timeOut);
    }

    private tztZFNetTestConn initWithConnTimeOut(int timeOut) {
        this.m_nConnTimeOut = timeOut;
        return tztZFNetTestConn.this;
    }

    /**
     * 创建tztZFNetTestConn对象
     * @param timeOut 链接超时时间
     * @return tztZFNetTestConn对象
     */
    public static tztZFNetTestConn WithConnTimeOut(int timeOut) {
        return getShareInstance().initWithConnTimeOut(timeOut);
    }


    /**
     * 退出测速
     */
    public static void Quit() {
        getShareInstance().onQuit();
    }

    /**
     * 执行测速
     * @param callBack 测速回调
     * @return 是否执行测速
     */
    public static boolean Test(tztZFNetPoolsCallBack callBack) {
        return getShareInstance().testNet(callBack);
    }

    private synchronized boolean testNet(final tztZFNetPoolsCallBack callBack) {
        if (_poolNet == null) {
            _poolNet = new tztZFPoolsShortNet("tztZFNetTest");

            final tztZFNetWorkReqObj reqObj = new tztZFNetWorkReqObj();
            reqObj.setInt("Action", 46);
            reqObj.setStr("Tip", "测速");
            return _poolNet.InitWithContext(context)
                    .InitWithNum(m_nNum)
                    .InitWithTimeOut(m_nTimeOut)
                    .InitWithConnTimeOut(m_nConnTimeOut)
                    .InitWithAddlist(m_sAddlist)
                    .InitWithLinktype(tztZFLinkType.tztZFLinkType_Short.value())
                    .DoPoolsAction(reqObj, new tztZFNetPoolsCallBack() {
                        @Override
                        public boolean onPools(int c_netIndex, String c_netAddress, tztZFNetWorkReqObj c_reqObj, tztZFNetWorkRespObj c_respObj) {
                            if (callBack != null) {
                                return callBack.onPools(c_netIndex, c_netAddress, c_reqObj, c_respObj);
                            }
                            return true;
                        }

                        @Override
                        public void onFinish(int c_netPools, String c_netAddList, tztZFNetWorkReqObj c_reqObj, tztZFNetWorkRespObj c_respObj) {
                            if (callBack != null) {
                                callBack.onFinish(c_netPools, c_netAddList, c_reqObj, c_respObj);
                            }
                            onQuit();
                        }
                    });
        }
        return false;
    }

    private synchronized void onQuit() {
        if (_poolNet != null) {
            _poolNet.QuitPools();
            _poolNet = null;
        }
    }
}

