package com.tztzf.protocol.define;

import static com.tztzf.protocol.define.tztZFAlgo_HandshakeType.tztZFAlgo_HandshakeType_ECC;
import static com.tztzf.protocol.define.tztZFAlgo_HandshakeType.tztZFAlgo_HandshakeType_Err;
import static com.tztzf.protocol.define.tztZFAlgo_HandshakeType.tztZFAlgo_HandshakeType_NON;
import static com.tztzf.protocol.define.tztZFAlgo_HandshakeType.tztZFAlgo_HandshakeType_RC;
import static com.tztzf.protocol.define.tztZFAlgo_HandshakeType.tztZFAlgo_HandshakeType_RSA;
import static com.tztzf.protocol.define.tztZFAlgo_HandshakeType.tztZFAlgo_HandshakeType_SM;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * 作者: yangdl 2019.06
 * 用途: 通讯协议分类-同tztZFAlgo_HandshakeType
 * 修改记录如下:
 *
 * @版本号: 1.00.001 2019.06.10
 * 更新说明: 第一版正式发布
 */
@tztZFIntDef({
        tztZFAlgo_HandshakeType_Err,
        tztZFAlgo_HandshakeType_RSA,
        tztZFAlgo_HandshakeType_SM,
        tztZFAlgo_HandshakeType_RC,
        tztZFAlgo_HandshakeType_ECC,
        tztZFAlgo_HandshakeType_NON
})
@Retention(RetentionPolicy.SOURCE)
public @interface tztZFAlgo_HandshakeType {
    int tztZFAlgo_HandshakeType_Err = (0); //错误
    int tztZFAlgo_HandshakeType_RSA = (1); //RSA编码
    int tztZFAlgo_HandshakeType_SM = (2);  //SM编码
    int tztZFAlgo_HandshakeType_RC = (4);  //RC编码
    int tztZFAlgo_HandshakeType_ECC = (8); //ECC编码
    int tztZFAlgo_HandshakeType_NON = (1 << 30); //不需要握手
}
