package com.tztzf.protocol.define;

/**
 * ****************************************************************
 * 文件名称 : tztZFOperType
 * 作   者 : Created by yangares
 * 创建时间 : 2020-06-19 10:12
 * 文件描述 :
 * 注意事项 :
 * 版权声明 : Copyright (C) 2015-2025 杭州中焯信息技术股份有限公司
 * 修改历史 : 2020-06-19 1.00 初始版本
 * ****************************************************************
 */

import static com.tztzf.protocol.define.tztZFOperType.tztZFDecrypt;
import static com.tztzf.protocol.define.tztZFOperType.tztZFEncrypt;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * 编码/解码
 */
@tztZFIntDef({
        tztZFEncrypt,
        tztZFDecrypt
})
@Retention(RetentionPolicy.SOURCE)
public @interface tztZFOperType {
    /**
     * 编码
     */
    int tztZFEncrypt = (0);
    /**
     * 解码
     */
    int tztZFDecrypt = (1);
}
