package com.tztzf.protocol.define;

import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_ActionBusying;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_Check;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_ClientDisConn;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_ClientSend;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_Comm;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_DBMBegin;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_DBMEnd;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_Decode2016Error;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_ErrSend;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_Error;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_Failed;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandBegin;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandCCheck;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandCData;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandCKey;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandCSession;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandEnd;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandSData;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandSKey;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandSSession;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_HandshakeType;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_ModuleException;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_NotAllowProtocol;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_NotFindAction;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_PackIDCheckError;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_Protocol;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_RecvTimeOut;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_ReqListFull;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_Send;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_ServerDBM;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_ServerHand;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_ServerRecv;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_UnKnowAction;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_WaitTimeOut;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_paramError;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFHandshakeError_unFind;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFProtocolError_Action;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFProtocolError_Init;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFProtocolError_OK;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFProtocolError_RecvData;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFProtocolError_RecvDecode;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFProtocolError_SendData;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFProtocolError_SendEncode;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKApp;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKAppName;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKBad;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKCert;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKErr;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKFormat;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKID;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKKey;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKSession;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKUserID;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKtype;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKunCert;
import static com.tztzf.protocol.define.tztZFProtocolError.tztZFRegisterError_SDKunLinktype;

import com.tztzf.baseos.tztZFIntDef;
import com.tztzf.network.define.tztZFErrorMessageDefine;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/*
协议错误号
[01-20]证书注册
[21-30]通讯数据协议
[31-50]通讯协商
[989800-989899]服务器协商组件错误号段，PS：不可更改
[989900-989999]服务器接入错误号段，PS：不可更改
*/
@tztZFIntDef({
        tztZFProtocolError_OK,
        tztZFProtocolError_Init,
        tztZFRegisterError_SDKBad,
        tztZFRegisterError_SDKunCert,
        tztZFRegisterError_SDKtype,
        tztZFRegisterError_SDKCert,
        tztZFRegisterError_SDKFormat,
        tztZFRegisterError_SDKID,
        tztZFRegisterError_SDKKey,
        tztZFRegisterError_SDKApp,
        tztZFRegisterError_SDKAppName,
        tztZFRegisterError_SDKSession,
        tztZFRegisterError_SDKunLinktype,
        tztZFRegisterError_SDKUserID,
        tztZFRegisterError_SDKErr,
        tztZFProtocolError_SendData,
        tztZFProtocolError_SendEncode,
        tztZFProtocolError_RecvData,
        tztZFProtocolError_RecvDecode,
        tztZFProtocolError_Action,
        tztZFHandshakeError_Protocol,
        tztZFHandshakeError_HandshakeType,
        tztZFHandshakeError_ClientDisConn,
        tztZFHandshakeError_ClientSend,
        tztZFHandshakeError_RecvTimeOut,
        tztZFHandshakeError_Comm,
        tztZFHandshakeError_HandCKey,
        tztZFHandshakeError_HandCData,
        tztZFHandshakeError_HandSKey,
        tztZFHandshakeError_HandSData,
        tztZFHandshakeError_HandCCheck,
        tztZFHandshakeError_HandCSession,
        tztZFHandshakeError_HandSSession,
        tztZFHandshakeError_ServerRecv,
        tztZFHandshakeError_ServerHand,
        tztZFHandshakeError_ServerDBM,
        tztZFHandshakeError_HandBegin,

        tztZFHandshakeError_paramError,
        tztZFHandshakeError_Failed,
        tztZFHandshakeError_Error,
        tztZFHandshakeError_Check,
        tztZFHandshakeError_Send,
        tztZFHandshakeError_unFind,
        tztZFHandshakeError_ErrSend,

        tztZFHandshakeError_HandEnd,
        tztZFHandshakeError_DBMBegin,
        tztZFHandshakeError_ReqListFull,
        tztZFHandshakeError_WaitTimeOut,
        tztZFHandshakeError_ActionBusying,
        tztZFHandshakeError_PackIDCheckError,
        tztZFHandshakeError_Decode2016Error,
        tztZFHandshakeError_ModuleException,
        tztZFHandshakeError_NotFindAction,
        tztZFHandshakeError_NotAllowProtocol,
        tztZFHandshakeError_UnKnowAction,
        tztZFHandshakeError_DBMEnd
})

@Retention(RetentionPolicy.SOURCE)
public @interface tztZFProtocolError {
    int tztZFProtocolError_OK = 1; //成功
    int tztZFProtocolError_Init = 0; //初始状态

    /*[01-20]证书注册错误*/
    int tztZFRegisterError_SDKBad = -1;      //参数错误
    int tztZFRegisterError_SDKunCert = -2;   //证书不存在
    int tztZFRegisterError_SDKtype = -3;  //类别错误
    int tztZFRegisterError_SDKCert = -4;  //错误证书
    int tztZFRegisterError_SDKFormat = -5;//错误格式
    int tztZFRegisterError_SDKID = -6;    //ID错误
    int tztZFRegisterError_SDKKey = -7;    //Key错误
    int tztZFRegisterError_SDKApp = -8;  //APP错误
    int tztZFRegisterError_SDKAppName = -9;  //APP_NAME错误
    int tztZFRegisterError_SDKSession = -10; //APP_Session错误
    int tztZFRegisterError_SDKunLinktype = -11;  //证书未配置对应LinkType
    int tztZFRegisterError_SDKUserID = -12; //UserID错误
    int tztZFRegisterError_SDKErr = -20; //注册错误

    /*[21-30]通讯数据协议错误*/
    int tztZFProtocolError_SendData = -21; //数据错误
    int tztZFProtocolError_SendEncode = -22; //编码错误

    int tztZFProtocolError_RecvData = -25; //数据错误
    int tztZFProtocolError_RecvDecode = -26; //解码错误

    int tztZFProtocolError_Action = -30; //功能号错误


    /*[31-50]通讯协商错误*/

    int tztZFHandshakeError_Protocol = -31; //协议错误
    int tztZFHandshakeError_HandshakeType = -32; //协议错误

    int tztZFHandshakeError_ClientDisConn = -33; //客户端连接错误
    int tztZFHandshakeError_ClientSend = -34; //客户端请求错误
    int tztZFHandshakeError_RecvTimeOut = -35; //客户端应答错误

    int tztZFHandshakeError_Comm = -39; //其他错误

    int tztZFHandshakeError_HandCKey = -40; //客户端密钥错误
    int tztZFHandshakeError_HandCData = -41; //客户端协商打包错误
    int tztZFHandshakeError_HandSKey = -42;//密钥错误
    int tztZFHandshakeError_HandSData = -43; //客户端协商应答错误
    int tztZFHandshakeError_HandCCheck = -44;//客户端协商应答验证错误
    int tztZFHandshakeError_HandCSession = -45;//协商Session错误
    int tztZFHandshakeError_HandSSession = -46;//协商Session错误

    int tztZFHandshakeError_ServerRecv = -48; //其他应答错误
    int tztZFHandshakeError_ServerHand = -49; //服务器协商失败
    int tztZFHandshakeError_ServerDBM = -50; //服务器接入返回错误


    /*[989800-989899]服务器协商组件错误号段，与服务器协商组件统一定义，不可更改*/
    int tztZFHandshakeError_HandBegin = -989800; //协商组件错误号起始

    int tztZFHandshakeError_paramError = -989800; //协商参数错误
    int tztZFHandshakeError_Failed = -989801; //证书错误
    int tztZFHandshakeError_Error = -989802; //协商错误
    int tztZFHandshakeError_Check = -989803; //验证不通过
    int tztZFHandshakeError_Send = -989804; //协商失败
    int tztZFHandshakeError_unFind = -989805; //证书未找到
    int tztZFHandshakeError_ErrSend = -989806; //请求参数错误

    int tztZFHandshakeError_HandEnd = -989899; //协商组件错误号结束

    /*[989900-989999]服务器接入错误号段，与服务器接入统一定义，不可更改*/
    int tztZFHandshakeError_DBMBegin = -989900;//服务器接入错误号起始

    //cErrorMsg_ReqListFull = '请求队列已满，请稍后重试！';
    int tztZFHandshakeError_ReqListFull = -989999; //-9999

    //cErrorMsg_WaitTimeOut = '请求等待处理超时，请稍后重试！';
    int tztZFHandshakeError_WaitTimeOut = -989998; //-203011

    //cErrorMsg_ActionBusying = '请求处理不通畅，请稍后再来！';
    int tztZFHandshakeError_ActionBusying = -989997; //-202005
    //'服务器正忙，请稍后重试！';
    //'参加的人太多了，挤爆啦！'; for HT
    //'使用的人太多了，挤爆啦，请稍后再来！';

    //cErrorMsg_PackIDCheckError = '请求包序号校验失败！';
    int tztZFHandshakeError_PackIDCheckError = -989980; //-100

    //cErrorMsg_Decode2016Error = '请求包解码失败！';
    int tztZFHandshakeError_Decode2016Error = -989981; //-100

    //cErrorMsg_ModuleException = '请求处理不通畅，请稍后重试！';
    int tztZFHandshakeError_ModuleException = -989920; //-202005

    //cErrorMsg_NotFindAction =  '组件未加载或已暂停！';
    int tztZFHandshakeError_NotFindAction = -989921; //-202005

    //cErrorMsg_NetworkError = '连接不通畅，请稍后重试！';
    //tztZFHandshakeError_NetworkError = --989930, //-203017

    //cErrorMsg_NotFindForward =  '路由未配置或已删除！';
    //tztZFHandshakeError_NotFindForward  = -989931, //-202001

    //cErrorMsg_HSNCheckError = '路由请求唯一标识检验错误！';
    //tztZFHandshakeError_HSNCheckError = -989932, //-100

    //cErrorMsg_NotAllowProtocol = '本通讯协议已禁用，请求被拒绝！';
    int tztZFHandshakeError_NotAllowProtocol = -989900; //-100

    //cErrorMsg_NotAllowIP = '来源IP地址不在被允许的范围内，请求被拒绝！';
    //tztZFHandshakeError_NotAllowIP = -989901, //-100

    //cErrorMsg_NotOpenAction = '本功能只允许本机访问！';
    //tztZFHandshakeError_NotOpenAction  = -989902,

    //cErrorMsg_UnKnowAction: AnsiString = -'未知功能！';
    int tztZFHandshakeError_UnKnowAction = -989903; //-100

    //cErrorMsg_ClientClosed: AnsiString = '请求方连接已断开，请求被取消！';
    //tztZFHandshakeError_ClientClosed = -989904, //-203011

    //cErrorMsg_CallTooMany  = '请求被路由转发或组件调用的次数超限！';
    //tztZFHandshakeError_CallTooMany  = --989905, //-203017

    int tztZFHandshakeError_DBMEnd = -989999;//服务器接入错误号结束

    class tztZFProtocolErrorInfo {
        public static String errInfo(int value) {
            String certLable = tztZFErrorMessageDefine.getUserDefineError(tztZFErrorMessageDefine.tztZFNetWorkErrorKey_CertLable, tztZFErrorMessageDefine.tztZFCertLable);
            switch (value) {
                case tztZFRegisterError_SDKBad:
                    return "参数错误[%1$s]";
                case tztZFRegisterError_SDKunCert:
                    return certLable + "不存在[%1$s]";
                case tztZFRegisterError_SDKCert:
                case tztZFRegisterError_SDKFormat:
                case tztZFRegisterError_SDKSession:
                    return certLable + "不合法[%1$s]";
                case tztZFRegisterError_SDKtype:
                case tztZFRegisterError_SDKID:
                case tztZFRegisterError_SDKKey:
                case tztZFRegisterError_SDKApp:
                case tztZFRegisterError_SDKAppName:
                    return certLable + "不合法或不匹配[%1$s]";
                case tztZFRegisterError_SDKErr:
                    return certLable + "注册失败[%1$s]";
                default:
                    break;
            }
            return "";
        }
    }
}
