package com.tztzf.protocol.define;

import static com.tztzf.protocol.define.tztZFSSLCallbackType.tztZFSSLCallback_Cosign;
import static com.tztzf.protocol.define.tztZFSSLCallbackType.tztZFSSLCallback_Hand;
import static com.tztzf.protocol.define.tztZFSSLCallbackType.tztZFSSLCallback_Init;
import static com.tztzf.protocol.define.tztZFSSLCallbackType.tztZFSSLCallback_Read;
import static com.tztzf.protocol.define.tztZFSSLCallbackType.tztZFSSLCallback_Write;
import static com.tztzf.protocol.define.tztZFSSLCallbackType.tztZFSSLCallback_close;
import static com.tztzf.protocol.define.tztZFSSLCallbackType.tztZFSSLCallback_d2iSession;
import static com.tztzf.protocol.define.tztZFSSLCallbackType.tztZFSSLCallback_err;
import static com.tztzf.protocol.define.tztZFSSLCallbackType.tztZFSSLCallback_i2dSession;

import com.tztzf.baseos.tztZFIntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * tztZFVPNSSL回调类型
 */
@tztZFIntDef({
        tztZFSSLCallback_Init,
        tztZFSSLCallback_Hand,
        tztZFSSLCallback_Write,
        tztZFSSLCallback_Read,
        tztZFSSLCallback_Cosign,
        tztZFSSLCallback_i2dSession,
        tztZFSSLCallback_d2iSession,
        tztZFSSLCallback_close,
        tztZFSSLCallback_err
})
@Retention(RetentionPolicy.SOURCE)
public @interface tztZFSSLCallbackType {
    int tztZFSSLCallback_Init = (0);//初始
    int tztZFSSLCallback_Hand = (1);//握手
    int tztZFSSLCallback_Write = (2);//写
    int tztZFSSLCallback_Read = (3);//读
    int tztZFSSLCallback_Cosign = (4);//签名
    int tztZFSSLCallback_i2dSession = (5);//写session
    int tztZFSSLCallback_d2iSession = (6);//读session
    int tztZFSSLCallback_close = 7;//关闭
    int tztZFSSLCallback_err = 99; ///错误
}
