package com.tztzf.protocol.tztnative;

import com.tztzf.soloader.tztZFSoLoader;

/**
 * 作者: yangdl 2019.06
 * 用途: tztProtocol.so:NDK数据编解码处理
 * 修改记录如下:
 *
 * @版本号: 1.00.001 2019.06.10
 * 更新说明: 第一版正式发布
 */

public class tztNativePubFun {

    private static tztNativePubFun pubFunKit = new tztNativePubFun();

    private static byte[] byteseNull = null;

    static {
        tztZFSoLoader.loadLibrary("tztZFProtocol");
//        System.loadLibrary("tztZFProtocol");
    }

    private static tztNativePubFun getShareInstance() {
        if (pubFunKit == null)
            pubFunKit = new tztNativePubFun();
        return pubFunKit;
    }

    private static int getlen(byte[] data) {
        if (data != null)
            return data.length;
        return 0;
    }

    public static void tztZFCLog_setLevel(int level) {
        getShareInstance().tztZFCLogsetLevelNative(level);
    }

    public static byte[] decryptCertDataWithKeyWithType(byte[] sdkkey, byte[] sdkcert, int decrypttype) {
        return getShareInstance().decryptCertDataWithKeyWithTypeNative(sdkkey, getlen(sdkkey),
                sdkcert, getlen(sdkcert),
                decrypttype);
    }

    public static byte[] operDataWithCert(int operType, int userID, int sdkType, int linkType, byte[] data) {
        return getShareInstance().operDataWithCertNative(operType, userID, sdkType, linkType, data, getlen(data));
    }

    public static int tztZFDataProtocolHeader(int type) {
        return getShareInstance().tztZFDataProtocolHeaderNative(type);
    }

    //值,获取开始位置(从右边1开始),获取长度  返回获取位置的值
    public static int tztZFGetbit(int num, int bit, int len) {
        return getShareInstance().tztZFGetbitNative(num, bit, len);
    }

    //原始值,设置开始位置(从右边1开始),设置长度,设置的数据  返回设置后的新值
    public static int tztZFSetbit(int num, int bit, int len, int val) {
        return getShareInstance().tztZFSetbitNative(num, bit, len, val);
    }

    //默认ver
    public static int tzt_getAlgover(int protocoltype, int handtype, int encrypttype) {
        return getShareInstance().tztgetAlgoverNative(protocoltype, handtype, encrypttype);
    }
    //endregion

    //region NDK 函数
//------------------------------NDK 函数----------------------//
    private native int tztZFCLogsetLevelNative(int level);

    private native byte[] decryptCertDataWithKeyWithTypeNative(byte[] sdkkey, int sdkkeylen,
                                                               byte[] sdkcert, int sdkcertlen,
                                                               int decrypttype);

    private native byte[] operDataWithCertNative(int operType, int userID, int sdkType, int linkType, byte[] data, int datalen);

    private native int tztZFDataProtocolHeaderNative(int type);

    //值,获取开始位置(从右边1开始),获取长度  返回获取位置的值
    private native int tztZFGetbitNative(int num, int bit, int len);

    //原始值,设置开始位置(从右边1开始),设置长度,设置的数据  返回设置后的新值
    private native int tztZFSetbitNative(int num, int bit, int len, int val);

    //默认ver
    private native int tztgetAlgoverNative(int protocoltype, int handtype, int encrypttype);
    //endregion
}
